GuildHistoryTest = {
    name = "GuildHistoryTest",
    title = "Guild History Tester",
    author = "silvereyes",
    version = "0.2.1",
}

local addon = GuildHistoryTest

local function OnGuildHistoryResponseReceived()
    EVENT_MANAGER:UnregisterForUpdate(addon.name.."Timeout", Timeout)
    local numEvents = GetNumGuildEvents(addon.guildId, GUILD_HISTORY_STORE)
    local currentTimestamp = os.clock()
    local duration = currentTimestamp - addon.start
    d(GetTimeString() .. ": Number of sales: " .. tostring(numEvents) 
      .. ", Throughput: " .. tostring(numEvents/(currentTimestamp-addon.start)) 
      .. " sales / second, Total Time: " .. tostring(duration) .. " sec")
end

local function Timeout()
    EVENT_MANAGER:UnregisterForUpdate(addon.name.."Timeout")
    EVENT_MANAGER:UnregisterForUpdate(addon.name)
    d(GetTimeString() .. ": Stopping")
end

local function PollHistory()
    EVENT_MANAGER:UnregisterForUpdate(addon.name)
    if not HasOutstandingGuildHistoryRequest() then
        RequestMoreGuildHistoryCategoryEvents(addon.guildId, GUILD_HISTORY_STORE)
        EVENT_MANAGER:RegisterForUpdate(addon.name.."Timeout", 10000, Timeout)
    end
    EVENT_MANAGER:RegisterForUpdate(addon.name, 1000, PollHistory)
end

local function SlashCommand(argument)
    addon.guildId = GetGuildId(tonumber(argument))
    addon.start = os.clock()
    d(GetTimeString() .. ": Starting to search guild "  .. GetGuildName(addon.guildId) .. " for sales.")
    PollHistory()
end

local function OnAddonLoaded(event, name)
    if name ~= addon.name then return end
    EVENT_MANAGER:UnregisterForEvent(addon.name, EVENT_ADD_ON_LOADED)
    EVENT_MANAGER:RegisterForEvent(addon.name, EVENT_GUILD_HISTORY_RESPONSE_RECEIVED, OnGuildHistoryResponseReceived)
    SLASH_COMMANDS["/guildhistorytest"] = SlashCommand
end

EVENT_MANAGER:RegisterForEvent(addon.name, EVENT_ADD_ON_LOADED, OnAddonLoaded)